#include "poti.h"


int16_t normalize(int16_t sens, int16_t middle, int16_t target, int16_t range, int16_t min, int16_t max)
{
  int16_t value;

  value = (int16_t)(((long)((sens-middle))*(long)(target))/range);
  if (value > max) value = max;
  if (value < min) value = min;

  return value;
}


void UpdatePoti()
{
/* Update Results from ADAC for Pads stearing only when ADAC is ready ADSC 1->0
 * to save the time no function parameters
 * side efect update of global variables: 
 * LPoti, RPoti, LPotiP, LPotiD, RPotiP, RPotiD
*/
static uint8_t PotiSwitch = 0b0111;	// Use to switch ADAC multiplexer
static int16_t RPoti = 0;
static int16_t LPoti = 0;
 
	if ( !(ADCSRA & _BV(ADSC)) ) 		// current measurement ready
	{ 
		if ( PotiSwitch == 0b0111)		// check the side ADC7 = Right Poti
		{
			RPoti = ADC;
			ADMUX &= ~(_BV(MUX2) | _BV(MUX1) | _BV(MUX0));	
			ADMUX |= _BV(MUX2) | _BV(MUX1);
			PotiSwitch = 0b0110;		// Next measurement for ADC6
		}
		else							// the other side -< ADC6 = Left Poti
		{
			LPoti = ADC;
			ADMUX &= ~(_BV(MUX2) | _BV(MUX1));	
			ADMUX |= _BV(MUX2) | _BV(MUX1) | _BV(MUX0);
			PotiSwitch =0b0111;
		}
		ADCSRA |= _BV(ADSC); // Start new measuremnt
 	    joyX = (int8_t)(normalize(RPoti, (joyXmax+joyXmin)/2, 255, joyXmax-joyXmin, -127, 127));
  		joyY = (int8_t)(normalize(LPoti, (joyYmax+joyYmin)/2, 255, joyYmax-joyYmin, -127, 127));
	}
}



